#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<ctime>
#include<algorithm>
#define MAXN 128
#define MAXX 10257
using namespace std;

struct Decoration {
    int likes;
    int n, m, u;
    bool matrix[MAXN][MAXN];
};

struct Answer{
    int w, l, p;
    int likes;
}Ans[MAXX];

struct Window{
    int n, m;
    bool matrix[MAXN][MAXN];
    int u;
}Win[MAXX];

Decoration D[MAXX];
Answer CurrentBest[MAXX];
int N, M, CurrBest;
int currObscenity_i, currObscenity_j;

bool fun (Decoration i, Decoration j){
    if (i.likes > j.likes) return 1;
    return 0;
}

bool fun_area (Decoration i, Decoration j){
    if (i.m*i.n > j.m*j.n) return 1;
    return 0;
}

bool fun_win (Window i, Window j){
    if (i.m*i.n > j.n*j.m) return 1;
    return 0;
}

void init (){
    scanf ("%d %d",&N, &M);

    for (int i = 1; i<=N; i++){
        scanf ("%d %d",&Win[i].n, &Win[i].m);
        Win[i].u = i;
    }

    for (int i = 1; i<=M; i++){
        scanf ("%d %d %d",&D[i].n, &D[i].m, &D[i].likes);

        for (int p = 0; p < D[i].n; p++)
            for (int l = 0; l < D[i].m; l++)
                scanf ("%d",&D[i].matrix[p][l]);

        D[i].u = i;
    }
}

void Place_it (int a, int b){
    Ans[D[a].u].w = Win[b].u;
    Ans[D[a].u].l = currObscenity_i + 1;
    Ans[D[a].u].p = currObscenity_j + 1;

    for (int l = 0; l < D[a].n; l++)
        for (int p = 0; p < D[a].m; p++){
            if (D[a].matrix[l][p] == 1) Win[b].matrix[currObscenity_i+l][currObscenity_j+p] ^= 1;
    }
}

bool Fits (int a, int b){
    int n = Win[b].n;
    int m = Win[b].m;

    if (D[a].n > n || D[a].m > m) return 0;

    for (int i = 0; i + D[a].n - 1 < n; i++)
        for (int j = 0; j + D[a].m - 1 < m ; j++){

            int bla = 0;

            for (int l = 0; l < D[a].n; l++){
                if (bla == 1) break;
                for (int p = 0; p < D[a].m; p++){
                    if (D[a].matrix[l][p] == 1)
                        if (Win[b].matrix[i+l][j+p] == 1){bla = 1; break;}
                }
            }

            if (bla == 0){
                currObscenity_i = i;
                currObscenity_j = j;
                return 1;
            }
        }

    return 0;
}

void print (int a){
    cout << a << endl;

    int n = Win[a].n;
    int m = Win[a].m;

    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++)
            cout << Win[a].matrix[i][j] ;
        cout << endl;
    }
    cout << endl << endl;
}

void Solution (){
    for (int i = 1; i <= M ; i++){
        int used = 0;

        for (int j = 1; j <= N; j++)
            if (Fits (i, j)) {
                Place_it (i, j);
                used ^= 1;
                break;
            }

        if (used == 0) Ans[D[i].u].w = Ans[D[i].u].l = Ans[D[i].u].p = -1;
        else Ans[D[i].u].likes = D[i].likes;
    }
}

int Determinate_Score (){
    pair<int, int> score[MAXX];
    memset (score, 0, sizeof(score));

    for (int i=1; i<=M; i++){
        int w = Ans[i].w;

        if (w == -1) continue;

        score[w].first++;
        score[w].second+=Ans[i].likes;
    }

    int all = 0;

    for (int i=1; i<=N; i++){
        all += score[i].first*score[i].second;
    }

    return all;
}

void Clear (){
    memset (Ans, -1, sizeof (Ans));
    for (int i=1; i<=N; i++)
        memset (Win[i].matrix, 0, sizeof (Win[i].matrix));
}

void Replace (){
    for (int i=1; i<=M; i++){
        CurrentBest[i].w = Ans[i].w;
        CurrentBest[i].l = Ans[i].l;
        CurrentBest[i].p = Ans[i].p;
    }
}

bool Time (){
    int time = clock ();
    int Limit = 4.8*CLOCKS_PER_SEC;

    if (time > Limit) return 0;
    return 1;
}

int main (){
    freopen("decoration.in","r",stdin);
    freopen("decoration.out","w",stdout);

    srand (10934);
    init ();

    sort (D+1, D+M+1, fun);
    sort (Win+1, Win+N+1, fun_win);

    Solution ();

    int Current = Determinate_Score ();
    if (Current > CurrBest) {
        CurrBest = Current;
        Replace ();
    }

    Clear ();

    sort (D+1, D+M+1, fun_area);
    Solution ();

    Current = Determinate_Score ();
    if (Current > CurrBest) {
        CurrBest = Current;
        Replace ();
    }

    Clear ();

    while (Time ()){
        random_shuffle (D+1, D+M+1);

        Solution ();

        Current = Determinate_Score ();
        if (Current > CurrBest) {
            CurrBest = Current;
            Replace ();
        }

        Clear ();
    }

    for (int i=1; i<=M; i++){
        printf ("%d %d %d\n",CurrentBest[i].w, CurrentBest[i].l, CurrentBest[i].p);
    }

//    cout << CurrBest << endl;
    return 0;
}
